function [distMtx,tr] = DiffusionDistanceMatrix(evecs,evals,timeVal)

nEvals = numel(evals);
nVert = size(evecs,1);
evals = evals(:);

[I,J] = meshgrid(1:nVert);
I = nonzeros(triu(I,1));
J = nonzeros(triu(J,1));

%%
nParallel = 8;
distVals = zeros(size(I));
minError = 1e-2;
tr = 0;
for iVal = 1:nParallel:nEvals
    
    curVals = iVal:min(iVal+nParallel-1,nEvals);
    curVecs = evecs(:,curVals);
    val2add = (bsxfun(@minus,curVecs(I,:) , curVecs(J,:))).^2 * exp(-evals(curVals) * timeVal);
    
    if nargout > 1,
        tr = tr + sum(exp(-evals(curVals) * timeVal));
    end
    
    if  max(val2add./distVals) > minError
        distVals = distVals + val2add;
    else
        break
    end
    
end
%%

Idxs = sub2ind([nVert nVert],I,J);

distMtx = zeros(nVert);
distMtx(Idxs) = distVals;
distMtx = distMtx + distMtx';
%


